<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\ClassOfAccount;
use App\Branches;
use App\Customer;
use App\AdminPurchaesInvoice;
use App\supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
class GroupSummaryReportController extends Controller
{
    public function view()
    {
        $classOfAccounts = ClassOfAccount::all();

        return view('crusher.reports.group_summary', ['classOfAccounts' => $classOfAccounts]);
    }
    public function groupSummaryReport(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $classOfAccountId = $request->select_class_of_account;

        $customers = Customer::with('classOfAccount')->where('class_of_account_id', $classOfAccountId)->get();
        $StaffAndSalesman = StaffAndSalesman::with('classOfAccount')->where('class_of_account_id', $classOfAccountId)->get();
        $Supplier = Supplier::with('classOfAccount')->where('class_of_account_id', $classOfAccountId)->get();
        $Expense = Expense::with('classOfAccount')->where('class_of_account_id', $classOfAccountId)->get();
        $AdminOtherAccount = AdminOtherAccount::with('classOfAccount')->where('class_of_account', $classOfAccountId)->get();

        $allAccounts = $customers->merge($StaffAndSalesman)->merge($Supplier)->merge($Expense)->merge($AdminOtherAccount);

        $saleInvoices = [];

        foreach ($allAccounts as $account) {
            $invoicesSalesInvoice = AdminSalesInvoice::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $saleInvoices = array_merge($saleInvoices, $invoicesSalesInvoice->toArray());
        }
        $PurchaesInvoice = [];

        foreach ($allAccounts as $account) {
            $invoicesPurchaesInvoice = AdminPurchaesInvoice::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $PurchaesInvoice = array_merge($PurchaesInvoice, $invoicesPurchaesInvoice->toArray());
        }
        $JournalVoucher = [];

        foreach ($allAccounts as $account) {
            $invoicesJournalVoucher = AdminJournalVoucher::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $JournalVoucher = array_merge($JournalVoucher, $invoicesJournalVoucher->toArray());
        }
        $ReceiptVoucher = [];

        foreach ($allAccounts as $account) {
            $invoicesReceiptVoucher = ReceiptVoucherExpense::with('account')
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('account_id', $account->id)
                ->groupBy('invoice_no')
                ->get();

            $ReceiptVoucher = array_merge($ReceiptVoucher, $invoicesReceiptVoucher->toArray());
        }
        $PaymentVoucher = [];

        foreach ($allAccounts as $account) {
            $invoicesPaymentVoucher = PaymentVoucherExpense::with('account')
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->where('account_id', $account->id)
                ->groupBy('invoice_no')

                ->get();

            $PaymentVoucher = array_merge($PaymentVoucher, $invoicesPaymentVoucher->toArray());
        }
        $CreditNote = [];

        foreach ($allAccounts as $account) {
            $invoicesCreditNote = CreditNote::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $CreditNote = array_merge($CreditNote, $invoicesCreditNote->toArray());
        }
        $DebitNote = [];

        foreach ($allAccounts as $account) {
            $invoicesDebitNote = DebitNote::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $DebitNote = array_merge($DebitNote, $invoicesDebitNote->toArray());
        }
        $PurchaseOrder = [];

        foreach ($allAccounts as $account) {
            $invoicesPurchaseOrder = PurchaseOrder::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('invoice_no')
                ->get();

            $PurchaseOrder = array_merge($PurchaseOrder, $invoicesPurchaseOrder->toArray());
        }
        $Quotation = [];

        foreach ($allAccounts as $account) {
            $invoicesQuotation = Quotation::with('account')
                ->where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->groupBy('quotation_no')
                ->get();

            $Quotation = array_merge($Quotation, $invoicesQuotation->toArray());
        }

        // dd($invoices);
        return view('crusher.reports.group-summary-report', compact('from_date', 'to_date', 'classOfAccountId', 'saleInvoices','PurchaesInvoice','JournalVoucher','ReceiptVoucher','PaymentVoucher','CreditNote','DebitNote','PurchaseOrder','Quotation'));
    }



    // public function groupSummaryReport(Request $request)
    // {
    //     $from_date = $request->from_date;
    //     $to_date = $request->to_date;
    //     $classOfAccountId = $request->input('select_class_of_account');

    //     $customers = Customer::where('class_of_account_id', $classOfAccountId)->get();
    //     $suppliers = Supplier::where('class_of_account_id', $classOfAccountId)->get();
    //     $expenses = Expense::where('class_of_account_id', $classOfAccountId)->get();
    //     $adminOtherAccounts = AdminOtherAccount::where('class_of_account', $classOfAccountId)->get();

    //     $allAccounts = $customers->merge($suppliers)->merge($expenses)->merge($adminOtherAccounts)->unique('id');
    //     $invoices = [];

    //     foreach ($allAccounts as $account) {
    //         $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $from_date . ' 00:00:00')
    //             ->where('date', '<=', $to_date . ' 23:59:59')
    //             ->get();
    //         $SaleInvoice = AdminSalesInvoice::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $from_date . ' 00:00:00')
    //             ->where('date', '<=', $to_date . ' 23:59:59')
    //             ->get();
    //         $JournalVoucher = AdminJournalVoucher::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $from_date . ' 00:00:00')
    //             ->where('date', '<=', $to_date . ' 23:59:59')
    //             ->get();
    //         $ReceiptVoucher = ReceiptVoucherExpense::where('account_id', $account->id)
    //             // ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //             ->get();
    //         $PaymentVoucher = PaymentVoucherExpense::where('account_id', $account->id)
    //             // ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //                 ->get();
    //         $CreditNote = CreditNote::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //                 ->get();
    //         $DebitNote = DebitNote::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //                 ->get();

    //         $PurchaseOrder = PurchaseOrder::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //                 ->get();
    //         $Quotation = Quotation::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('created_at', '>=', $from_date . ' 00:00:00')
    //             ->where('created_at', '<=', $to_date . ' 23:59:59')
    //                 ->get();

    //                 $invoices = array_merge(
    //                     $invoices,
    //                     $SaleInvoice->toArray(),
    //                     $JournalVoucher->toArray(),
    //                     $ReceiptVoucher->toArray(),
    //                     $PaymentVoucher->toArray(),
    //                     $CreditNote->toArray(),
    //                     $DebitNote->toArray(),
    //                     $PurchaseOrder->toArray(),
    //                     $Quotation->toArray(),
    //                     $PurchaesInvoice->toArray()
    //                 );

    //     }
    //     // dd($invoices);
    //     return view('crusher.reports.group-summary-report', compact('from_date', 'to_date', 'invoices'));
    // }

    // public function groupSummaryReport(Request $request)
    // {
    //     $from_date = $request->from_date;
    //     $to_date = $request->to_date;
    //     $classOfAccountId = $request->input('select_class_of_account');

    //     $customers = Customer::where('class_of_account_id', $classOfAccountId)->get();
    //     $suppliers = Supplier::where('class_of_account_id', $classOfAccountId)->get();
    //     $staffAndSalesmen = StaffAndSalesman::where('class_of_account_id', $classOfAccountId)->get();
    //     $expenses = Expense::where('class_of_account_id', $classOfAccountId)->get();
    //     $adminOtherAccounts = AdminOtherAccount::where('class_of_account_id', $classOfAccountId)->get();

    //     $allAccounts = $customers->merge($suppliers)->merge($staffAndSalesmen)->merge($expenses)->merge($adminOtherAccounts);

    //     $invoices = [];

    //     foreach ($allAccounts as $account) {
    //         $invoicesForAccount = AdminPurchaesInvoice::where('account_id', $account->id)
    //             ->where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $from_date . ' 00:00:00')
    //             ->where('date', '<=', $to_date . ' 23:59:59')
    //             ->get();

    //         $invoices = array_merge($invoices, $invoicesForAccount->toArray());
    //     }

    //     return view('crusher.reports.group-summary-report', compact('from_date', 'to_date', 'invoices'));
    // }



    public function index(Request $request)
    {

        $branch_id = Brancehs::getBranches();
        $from_date = $request->from_date;
        $to_date = $request->to_date;


        $class_of_account = $request->select_account_class;
        $account_masters = AccountMaster::Where('class_of_account_id', $class_of_account)->pluck('id');
        // dd(count($account_masters));
        // $accounts = [];
        // if ( count($account_masters) > 0) {
            // foreach ($account_masters as $account_master) {
                $accounts = AccountMastersAccountsDetail::with(['account_master' => function($q) use ($location_id) {
            $q->where('location_id', $location_id);}])->WhereIn('account_master_id', $account_masters)->Where('date', '>=' , $from_date)->Where('date', '<=' , $to_date)->get();
            // }

        // }else {
        //     $accounts = [];

        // }
        // dd($accounts);
        return view('user.reports.group_summary.index', compact('decimal','accounts','from_date','to_date','class_of_account'));
    }

}
