<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\DB;
use App\AdminPurchaesInvoice;
use App\CreditNote;

use Illuminate\Http\Request;

class PurchaseReportController extends Controller
{
    public function view()
    {
        // dd(123);
        $selectedBranchId = session('selected_branch');

        $Debits = AdminPurchaesInvoice::with('account')->addSelect(DB::raw('id, account_id, account_type'), DB::raw('DATE(date) as date'), 'invoice_no', DB::raw('SUM(total_net_amount) as total_net_amount'))
            ->where('branch_id', $selectedBranchId)
            ->groupBy(DB::raw('DATE(date)'), 'invoice_no')
            ->orderBy(DB::raw('DATE(date)'))
            ->get();

        $Credits = CreditNote::with('account')->addSelect(DB::raw('id, account_id, account_type'), DB::raw('DATE(date) as date'), 'invoice_no', DB::raw('SUM(total_net_amount) as total_net_amount'))
            ->where('branch_id', $selectedBranchId)
            ->groupBy(DB::raw('DATE(date)'), 'invoice_no')
            ->orderBy(DB::raw('DATE(date)'))
            ->get();

        $mergedData = $Debits->concat($Credits);
        // dd($mergedData);
        $totalDebits = $Debits->sum('total_net_amount');
        $totalCredits = $Credits->sum('total_net_amount');

        return view('crusher.reports.purchase_report', [
            'mergedData' => $mergedData,
            'totalDebits' => $totalDebits,
            'totalCredits' => $totalCredits,
        ]);
    }
}
