<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;
class StatmentOfAccountController extends Controller
{
    public function display()
    {
        $user = Auth::user();
        // if (!$user->can('reports.statement_account')) {
        //     //     abort(403, 'Unauthorized action.');
        //     // }

        $accounts = [];

        $customers = Customer::where('branch_id', session()->get('selected_branch'))
            ->select('*', 'name_of_organisation as account_name')
            ->get()
            ->map(function ($item) {
                return $item->setAttribute('table_name', 'App\Customer');
            });

        $salesmens = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            ->select('*', DB::raw("CONCAT(first_name, ' ', last_name) as account_name"))
            ->get()
            ->map(function ($item) {
                return $item->setAttribute('table_name', 'App\StaffAndSalesman');
            });

        $suppliers = Supplier::where('branch_id', session()->get('selected_branch'))
            ->select('*', 'name_of_organisation as account_name')
            ->get()
            ->map(function ($item) {
                return $item->setAttribute('table_name', 'App\Supplier');
            });

        $expenses = Expense::where('branch_id', session()->get('selected_branch'))
            ->get()
            ->map(function ($item) {
                return $item->setAttribute('table_name', 'App\Expense');
            });

        $otherAccounts = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->get()
            ->map(function ($item) {
                return $item->setAttribute('table_name', 'App\AdminOtherAccount');
            });

        $accounts = $customers->concat($expenses)->concat($suppliers)->concat($otherAccounts)->concat($salesmens);

        $class_of_accounts = ClassOfAccount::all();

        return view('crusher.reports.statement_account', compact('accounts', 'class_of_accounts'));
    }

    public function index_class(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $classOfAccountId = $request->class_of_account;

        $ClassOfAccount = ClassOfAccount::find($classOfAccountId);

        $customers = Customer::where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation']);
        $suppliers = Supplier::where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organisation']);
        $expenses = Expense::where('class_of_account_id', $classOfAccountId)->get(['id', 'account_name']);
        $adminOtherAccounts = AdminOtherAccount::where('class_of_account', $classOfAccountId)->get(['id', 'account_name']);
        $allAccounts = $customers->merge($suppliers)->merge($expenses)->merge($adminOtherAccounts)->unique('id');

        $invoices = [];

        foreach ($allAccounts as $account) {
            $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->get();
            $SaleInvoice = AdminSalesInvoice::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->get();
            $JournalVoucher = AdminJournalVoucher::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->get();
            $ReceiptVoucher = ReceiptVoucherExpense::where('account_id', $account->id)
                // ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->get();
            $PaymentVoucher = PaymentVoucherExpense::where('account_id', $account->id)
                // ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                //  ->groupBy('invoice_no')
                    ->get();
            $CreditNote = CreditNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                    ->get();
            $DebitNote = DebitNote::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                    ->get();

            $PurchaseOrder = PurchaseOrder::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                    ->get();
            $Quotation = Quotation::where('account_id', $account->id)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                    ->get();

                    $invoices = array_merge(
                        $invoices,
                        $SaleInvoice->toArray(),
                        $JournalVoucher->toArray(),
                        $ReceiptVoucher->toArray(),
                        $PaymentVoucher->toArray(),
                        $CreditNote->toArray(),
                        $DebitNote->toArray(),
                        $PurchaseOrder->toArray(),
                        $Quotation->toArray(),
                        $PurchaesInvoice->toArray()
                    );


        }
        // dd($invoices);
        return view('crusher.reports.index_class_of_account', compact('from_date', 'to_date', 'invoices','allAccounts','ClassOfAccount'));
    }



   // $expenses = Expense::where('class_of_account_id', $classOfAccountId)->get(['id', 'name_of_organization']);
        // $adminOtherAccounts = AdminOtherAccount::where('class_of_account', $classOfAccountId)->get(['id', 'name_of_organization']);

        // $allAccounts = $customers->merge($suppliers);


    public function index_ledger_billwise(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $ledger_class = $request->ledger_class;

        $customer = Customer::find($ledger_class);
        $staffAndSalesman = StaffAndSalesman::find($ledger_class);
        $supplier = Supplier::find($ledger_class);
        $expense = Expense::find($ledger_class);
        $adminOtherAccount = AdminOtherAccount::find($ledger_class);

        $matchedAccount = null;
        $PurchaesInvoice = null;

        if ($customer || $staffAndSalesman || $supplier || $expense || $adminOtherAccount) {
            if ($customer) {
                $matchedAccount = $customer;
            } elseif ($staffAndSalesman) {
                $matchedAccount = $staffAndSalesman;
            } elseif ($supplier) {
                $matchedAccount = $supplier;
            } elseif ($expense) {
                $matchedAccount = $expense;
            } elseif ($adminOtherAccount) {
                $matchedAccount = $adminOtherAccount;
            }

            $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();
        }
        return view('crusher.reports.index_ledger_billwise', compact('from_date', 'to_date', 'ledger_class', 'matchedAccount', 'PurchaesInvoice','SaleInvoice'));
    }

    public function index_ledger_vatwise(request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $ledger_class = $request->ledger_class;

        $customer = Customer::find($ledger_class);
        $staffAndSalesman = StaffAndSalesman::find($ledger_class);
        $supplier = Supplier::find($ledger_class);
        $expense = Expense::find($ledger_class);
        $adminOtherAccount = AdminOtherAccount::find($ledger_class);

        $matchedAccount = null;
        $PurchaesInvoice = null;

        if ($customer || $staffAndSalesman || $supplier || $expense || $adminOtherAccount) {
            if ($customer) {
                $matchedAccount = $customer;
            } elseif ($staffAndSalesman) {
                $matchedAccount = $staffAndSalesman;
            } elseif ($supplier) {
                $matchedAccount = $supplier;
            } elseif ($expense) {
                $matchedAccount = $expense;
            } elseif ($adminOtherAccount) {
                $matchedAccount = $adminOtherAccount;
            }

            $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();

        }
        return view('crusher.reports.index_ledger_vatwise', compact('from_date', 'to_date', 'ledger_class', 'matchedAccount', 'PurchaesInvoice','SaleInvoice'));

    }
    // public function index_ledger_vatwise(Request $request, $accountId)
    // {
    //     $vatOption = $request->input('vatOption');

    //     // Fetch data based on $accountId and $vatOption
    //     // Replace 'yourData' with the actual query to fetch the data

    //     $deliveryNoteData = DeliveryNote::where('account_id', $accountId)
    //         ->where('vat_option', $vatOption)
    //         ->get();

    //     // Return the data as a JSON response
    //     return view('crusher.reports.index_ledger_vatwise', compact('deliveryNoteData'));
    // }

    public function view1()
    {
        return view('crusher.reports.statement_account_1');
    }

    public function ledgerReport(Request $request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');
        // dd($lastDay, $lastFromDate);

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $ledger_class = $request->ledger_class;

        $customer = Customer::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $from_date . ' 00:00:00')
            // ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('id', $ledger_class)
            ->first();

        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))
            // ->where('date_of_joining', '>=', $from_date . ' 00:00:00')
            // ->where('date_of_joining', '<=', $to_date . ' 23:59:59')
            ->where('id', $ledger_class)
            ->first();
        $supplier = Supplier::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $from_date . ' 00:00:00')
            // ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('id', $ledger_class)
            ->first();
        $expense = Expense::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $from_date . ' 00:00:00')
            // ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('id', $ledger_class)
            ->first();
        $adminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            // ->where('date', '>=', $from_date . ' 00:00:00')
            // ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('id', $ledger_class)
            ->first();

        $matchedAccount = null;
        $PurchaesInvoice = null;
        $JournalVoucher = null;
        $ReceiptVoucher = null;
        $PaymentVoucher = null;
        $DeliveryNote = null;
        $CreditNote = null;
        $DebitNote = null;
        $PurchaseOrder = null;
        $Quotation = null;
        $openingBalance = null;
        $SaleInvoice     = null;
        $ObDebit = null;
        $ObCredit = null;
        $CreateDebitOpeningBalance = null;
        $CreateCreditOpeningBalance = null;

        if ($customer || $staffAndSalesman || $supplier || $expense || $adminOtherAccount) {
            if ($customer) {
                $matchedAccount = $customer;
            } elseif ($staffAndSalesman) {
                $matchedAccount = $staffAndSalesman;
            } elseif ($supplier) {
                $matchedAccount = $supplier;
            } elseif ($expense) {
                $matchedAccount = $expense;
            } elseif ($adminOtherAccount) {
                $matchedAccount = $adminOtherAccount;
            }

            $PurchaesInvoice = AdminPurchaesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();

            $SaleInvoice = AdminSalesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();
            $JournalVoucher = AdminJournalVoucher::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                 ->groupBy('invoice_no')
                ->get();
                $ReceiptVoucher = AdminReceiptVoucher::with('expense')
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $from_date . ' 00:00:00')
                ->where('created_at', '<=', $to_date . ' 23:59:59')
                ->whereHas('expense', function ($query) use ($ledger_class) {
                    $query->where('account_id', $ledger_class);
                })
                ->groupBy('invoice_no')
                ->get();

            $PaymentVoucher = AdminPaymentVoucher::with('expense')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
            ->whereHas('expense', function ($query) use ($ledger_class) {
                $query->where('account_id', $ledger_class);
            })
             ->groupBy('invoice_no')
                ->get();
            $CreditNote = CreditNote::where('account_id', $ledger_class)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
             ->groupBy('invoice_no')
                ->get();
            $DebitNote = DebitNote::where('account_id', $ledger_class)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
             ->groupBy('invoice_no')
                ->get();

            $PurchaseOrder = PurchaseOrder::where('account_id', $ledger_class)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('created_at', '>=', $from_date . ' 00:00:00')
            ->where('created_at', '<=', $to_date . ' 23:59:59')
             ->groupBy('invoice_no')
                ->get();
            $Quotation = Quotation::where('account_id', $ledger_class)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
             ->groupBy('quotation_no')
                ->get();

            // OPENING BALANCE
            $ObPurchaesInvoice = AdminPurchaesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->sum('total_net_amount');
            // dd($ObPurchaesInvoice);

            $ObSaleInvoice = AdminSalesInvoice::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->sum('total_net_amount')
                ;
            $ObJournalVoucher = AdminJournalVoucher::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->sum('amount');

            $ObReceiptVoucher = ReceiptVoucherExpense::where('account_id', $ledger_class)
                // ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('created_at', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('inovice_id')
                ->sum('amount');

            $ObPaymentVoucher = PaymentVoucherExpense::where('account_id', $ledger_class)
                // ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('created_at', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('inovice_id')
                ->sum('amount');

            $ObCreditNote = CreditNote::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('created_at', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $ObDebitNote = DebitNote::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('invoice_no')
                ->sum('total_net_amount');

            $ObPurchaseOrder = PurchaseOrder::where('account_id', $ledger_class)
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            //  ->groupBy('invoice_no')
            ->sum('total_net_amount');

            $ObQuotation = Quotation::where('account_id', $ledger_class)
                ->where('branch_id', session()->get('selected_branch'))
                ->where('created_at', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('created_at', '<=', $oneDayPreviousDate . ' 23:59:59')
                //  ->groupBy('quotation_no')
                ->sum('total_net_amount');

            if (!empty($matchedAccount)) {
                $debitCardValue = optional($matchedAccount)->debit_card;
                $matchedAccountDate = optional($matchedAccount)->date;

                if ($matchedAccountDate >= $currentYearFirstDate &&
                    $matchedAccountDate <= $oneDayPreviousDate) {
                    if ($debitCardValue === 'Debit') {
                        $CreateDebitOpeningBalance = optional($matchedAccount)->opening_balance;
                    } elseif ($debitCardValue === 'Credit') {
                        $CreateCreditOpeningBalance = optional($matchedAccount)->opening_balance;
                    }
                }
            }

            // Opening Balance

            $debitTotal = $CreateDebitOpeningBalance + $ObSaleInvoice + $ObJournalVoucher + $ObPaymentVoucher + $ObCreditNote + $ObPurchaseOrder + $ObDebitNote  + $ObQuotation;
            $creditTotal = $ObPurchaesInvoice + $ObReceiptVoucher + $CreateCreditOpeningBalance;
            // $openingBalance = $debitTotal - $creditTotal;

            if ($debitTotal > $creditTotal) {
                $ObDebit = $debitTotal - $creditTotal;
            } elseif ($debitTotal < $creditTotal) {
                $ObCredit = $creditTotal - $debitTotal;
            }

            $DebitopeningBalance = $ObDebit;
            $creditOpeningBalance = $ObCredit;

            // dd($DebitopeningBalance,$creditOpeningBalance);

            // dd($debitTotal,$creditTotal);

            // dd($ObSaleInvoice);

            // dd($openingBalance);

            // dd($currentYearFirstDate,$oneDayPreviousDate,$ObSaleInvoice,$ObJournalVoucher,$ObReceiptVoucher,$ObPaymentVoucher,$ObCreditNote,$ObDebitNote,$ObPurchaseOrder,$ObQuotation);

            // dd($ObPurchaesInvoice);
            // dd($ObSaleInvoice, $ObJournalVoucher, $ObReceiptVoucher, $ObPaymentVoucher, $ObCreditNote, $ObDebitNote, $ObPurchaseOrder, $ObQuotation, $ObPurchaesInvoice);
        }


        return view('crusher.reports.ledger-report', compact('from_date', 'to_date', 'ledger_class', 'matchedAccount', 'PurchaesInvoice','JournalVoucher','ReceiptVoucher','PaymentVoucher','DeliveryNote','CreditNote','DebitNote','PurchaseOrder','Quotation', 'openingBalance','SaleInvoice','DebitopeningBalance','creditOpeningBalance'));
    }

}
