<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Customer;
use App\AdminPurchaesInvoice;
use App\supplier;
use App\StaffAndSalesman;
use App\Expense;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\ClassOfAccount;
class TrailBalanceReportController extends Controller
{
    public function view()
    {
        return view('crusher.reports.trail_balance_report');
    }
    // public function trailBalanceReport(request $request) {

    //     $from_date = $request->from_date;
    //     $to_date = $request->to_date;

    //     $class_of_accounts = ClassOfAccount::get();
    //     foreach ($class_of_accounts as $class_of_account){
    //         $debit = 0;
    //         $credit = 0;
    //         foreach ($class_of_account as $account_master){
    //             $debit = $debit + AccountMastersAccountsDetail::Where('account_master_id', $account_master->id)->Where('date', '>=' , $from_date)->Where('date', '<=' , $to_date)->sum('debit');
    //             $credit = $credit + AccountMastersAccountsDetail::Where('account_master_id', $account_master->id)->Where('date', '>=' , $from_date)->Where('date', '<=' , $to_date)->sum('credit');
    //         }
    //         $trial_balance_debit_credit[] = [
    //             "class_of_account" => $class_of_account->name,
    //             "debit" => $debit,
    //             "credit" => $credit,
    //             "debit_decimal" => number_format($debit, 2, '.', ''),
    //             "credit_decimal" => number_format($credit, 2, '.', '')
    //         ];
    //     }

    //     return view('crusher.reports.trail_balance_reports',compact('from_date','to_date'));
    // }
    public function trailBalanceReport(Request $request)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $classOfAccounts = ClassOfAccount::all();

        $allAccounts = collect();

        $customers = Customer::with('classOfAccount')->get();
        $staffAndSalesmen = StaffAndSalesman::with('classOfAccount')->get();
        $suppliers = Supplier::with('classOfAccount')->get();
        $expenses = Expense::with('classOfAccount')->get();
        $adminOtherAccounts = AdminOtherAccount::with('classOfAccount')->get();

        $allAccounts = $allAccounts->merge($customers)->merge($staffAndSalesmen)->merge($suppliers)->merge($expenses)->merge($adminOtherAccounts);

        $saleInvoices = AdminSalesInvoice::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $purchasesInvoices = AdminPurchaesInvoice::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $journalVouchers = AdminJournalVoucher::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $receiptVouchers = ReceiptVoucherExpense::with('account')
            ->groupBy('inovice_id')
            ->get();

        $paymentVouchers = PaymentVoucherExpense::with('account')
            ->groupBy('inovice_id')
            ->get();

        $creditNotes = CreditNote::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $debitNotes = DebitNote::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $purchaseOrders = PurchaseOrder::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('invoice_no')
            ->get();

        $quotations = Quotation::with('account')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->groupBy('quotation_no')
            ->get();

        return view('crusher.reports.trail_balance_reports', compact(
            'from_date',
            'to_date',
            'classOfAccounts',
            'allAccounts',
            'saleInvoices',
            'purchasesInvoices',
            'journalVouchers',
            'receiptVouchers',
            'paymentVouchers',
            'creditNotes',
            'debitNotes',
            'purchaseOrders',
            'quotations'
        ));
    }

}


