<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateDeliveryNotesTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('delivery_notes', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('branch_id')->nullable();
            // $table->foreign('branch_id')->references('id')->on('branches')->onDelete('cascade');            
            // $table->foreign('quotation_id')->references('id')->on('quotations')->onDelete('cascade');
            $table->string('quotation_no')->nullable();
            $table->string('do_no')->nullable();
            $table->date('date')->nullable();
            $table->nullableMorphs('account'); //belong to App\Customer, App\Supplier, App\Expense, App\AdminOtherAccount
            // $table->unsignedBigInteger('customer_id')->nullable();
            // $table->foreign('customer_id')->references('id')->on('customers')->onDelete('cascade');
            $table->unsignedBigInteger('item_id')->nullable();
            $table->foreign('item_id')->references('id')->on('item_names')->onDelete('cascade');
            $table->string('item_description')->nullable();
            $table->bigInteger('quantity')->nullable();
            $table->bigInteger('total_quantity')->nullable();
            $table->string('narrations')->nullable();
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('delivery_notes');
    }
}
