<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreatePaymentVouchersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('payment_vouchers', function (Blueprint $table) {
            $table->id();
            $table->integer('location_id');
            $table->string('invoice_no');
            $table->string('date');
            // $table->integer('account_id');
            $table->integer('bank_account_id')->nullable();
            $table->integer('cash_account_id')->nullable();
            // $table->string('amount');
            // $table->string('remaining_amount');
            $table->string('payment_method');
            $table->string('cheaque_no')->nullable();
            $table->string('cheaque_date')->nullable();
            $table->string('bank_name')->nullable();
            $table->string('gross_total')->nullable();
            $table->string('net_total')->nullable();
            $table->string('amount_in_words');
            $table->integer('tax_account_id');
            $table->string('vat_amount')->nullable();
            $table->string('narrations')->nullable();
            $table->softDeletes();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('payment_vouchers');
    }
}
