@extends('layouts.crusher')
@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Purchase Report</h6>
                        </div>

                    </div>
                    <!-- <div class="col-4"> -->
                    <form action="#" class="outer-repeater">


                        <div class="row">

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>From Date</label>
                                    <input class="form-control" type="date" id="fromDate" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                            <div class="col-md-6">
                                <div class="form-group">
                                    <label>To Date</label>
                                    <input class="form-control" type="date" id="toDate" pattern="\d{4}-\d{2}-\d{2}">
                                </div>
                            </div>

                        </div>



                        <button class="btn btn-cust1" type="submit" id="filterDataBtn"><i class="fas fa-check"></i>
                            Disply</button>



                    </form>

                    <br><br><br>

                    <div class="row">
                        <div class="col-md-6">
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a href="" type="button" class="btn btn-outline-primary"> Print & PDF
                                    Formate</a>

                            </div>
                            <!-- <a href="client-add-expenses.html">
                                            <button class="btn btn-cust2 float-right" type="submit">
                                                <i class="fas fa-mail-bulk"></i>Email (PDF Formate)
                                                </button>
                                        </a>
                                        <a href=""><button type="button" class="btn btn-cust2 float-right waves-effect waves-light">
                                             <i class="fas fa-print">Print </i> & <i class="fas fa-file-pdf">PDF Formate</i>
                                        </button></a> -->
                        </div>
                    </div>
                    <br>

                    <div class="table-responsive mb-0" data-pattern="priority-columns">
                        <table class="table table-bordered dt-responsive nowrap"
                            style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                            <thead>
                                <tr>
                                    <th>Date</th>
                                    <th>Particulars</th>
                                    <th>Voucher Description</th>
                                    <th>Debit</th>
                                    <th>Credit</th>
                                </tr>
                            </thead>

                            {{-- <tbody>
                                    <tr>
                                        <td colspan="3">Total Credit</td>
                                        <td></td>
                                        <td>0.000</td>
                                    </tr>
                                    <tr>
                                        <td colspan="3">Total Credit</td>
                                        <td>0.000</td>
                                        <td></td>
                                    </tr>
                                    <tr>
                                        <td colspan="3">Total</td>
                                        <td>0.000</td>
                                        <td></td>
                                    </tr>
                                </tbody> --}}
                            <tbody id="dataBody" style="display: none;">
                                @php
                                    $totalDebits = 0;
                                    $totalCredits = 0;
                                @endphp

                                @foreach ($mergedData as $data)
                                    <tr data-date="{{ \Carbon\Carbon::parse($data->date)->format('Y-m-d') }}">
                                        <td>{{ \Carbon\Carbon::parse($data->date)->format('d/m/Y') }}</td>
                                        <td>
                                            <span>
                                                {{
                                                    optional($data->account)->name_of_organisation ??
                                                    optional($data->account)->account_name ??
                                                    optional($data->account)->first_name . ' ' . optional($data->account)->last_name ??
                                                    ''
                                                }}
                                            </span>
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\AdminPurchaesInvoice)
                                                <span><strong><a href="{{ route('crusher.purchase_invoices.show', ['purchase_invoice' => $data->id]) }}">Puchase#
                                                    {{ $data->invoice_no }}</a></strong></span>
                                            @elseif ($data instanceof \App\CreditNote)
                                                <span><strong> <a href="{{ route('crusher.credit_notes.show', ['credit_note' => $data->id]) }}">Credit#
                                                    {{ $data->invoice_no }}</a></strong></span>
                                            @else
                                            @endif
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\AdminPurchaesInvoice)
                                                {{ $data->total_net_amount }}
                                                @php
                                                    $totalDebits += $data->total_net_amount;
                                                @endphp
                                            @else
                                                -
                                            @endif
                                        </td>
                                        <td>
                                            @if ($data instanceof \App\CreditNote)
                                                {{ $data->total_net_amount }}
                                                @php
                                                    $totalCredits += $data->total_net_amount;
                                                @endphp
                                            @else
                                                -
                                            @endif
                                        </td>
                                    </tr>
                                @endforeach
                                {{-- <tr>
                                    <td colspan="3">Total Credit</td>
                                    <td></td>
                                    <td>{{ $totalCredits }}</td>
                                </tr>
                                <tr>
                                    <td colspan="3">Total Debit</td>
                                    <td>{{ $totalDebits }}</td>
                                    <td></td>
                                </tr>
                                <tr>
                                    <td colspan="4">Total</td>
                                    <td>{{ $totalDebits * $totalCredits }}</td>
                                </tr> --}}
                                <tr id="totalsRow">
                                    <td colspan="3">Total</td>
                                    <td id="totalDebit"></td>
                                    <td id="totalCredit"></td>
                                    <td id="grandTotal"></td>
                                </tr>

                            </tbody>
                        </table>

                    </div>
                </div>
            </div>
        </div>
    </div>

    </div>
    <!-- end row -->
    <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script>
        $(document).ready(function() {
            $('#filterDataBtn').on('click', function(e) {
                e.preventDefault();

                var fromDate = $('#fromDate').val();
                var toDate = $('#toDate').val();

                var rows = $('#dataBody tr');

                rows.sort(function(a, b) {
                    var dateA = $(a).data('date');
                    var dateB = $(b).data('date');
                    return new Date(dateA) - new Date(dateB);
                });

                $('#dataBody').empty().append(rows);

                var totalDebit = 0;
                var totalCredit = 0;

                rows.each(function() {
                    var rowDate = $(this).data('date');

                    if (rowDate >= fromDate && rowDate <= toDate) {
                        $(this).show();

                        var debit = parseFloat($(this).find('td:nth-child(4)').text());
                        var credit = parseFloat($(this).find('td:nth-child(5)').text());

                        if (!isNaN(debit)) {
                            totalDebit += debit;
                        }

                        if (!isNaN(credit)) {
                            totalCredit += credit;
                        }
                    } else {
                        $(this).hide();
                    }
                });

                $('#totalDebit').text(totalDebit.toFixed(3));
                $('#totalCredit').text(totalCredit.toFixed(3));
                $('#grandTotal').text((totalCredit+totalDebit).toFixed(3));

                $('#dataBody').show();
                $('#totalsRow').show();
            });
        });
    </script>
@endsection
