@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Credit Note (Sales Return Voucher)</h6>
                            </div>
                            <div class="col-md-6">
                                <a href="{{ route("crusher.credit_notes.create") }}">
                                    <button class="btn btn-cust1 float-right" type="submit">Create Credit Note</button>
                                </a>
                            </div>
                        </div>
                        <!-- <div class="col-4"> -->


                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table id="datatable" class="table table-bordered nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>Date</th>
                                        <th>Credit Note #</th>
                                        <th>Sale Invoice #</th>
                                        <th>Amount</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>

                                <tbody>
                                    @forelse ($creditNotes as $creditNote)
                                        {{-- @dd($creditNote)     --}}
                                        <tr>
                                            <td>{{ $creditNote->date }}</td>
                                            <td>{{ $creditNote->invoice_no }}</td>
                                            <td>{{ $creditNote->sales_invoice_no }}</td>
                                            <td>{{ $creditNote->total_net_amount }}</td>
                                            <td>
                                                <a href="{{ route('crusher.credit_notes.show', ['credit_note' => $creditNote->id]) }}">
                                                    <i class="far fa-eye cust-icon2"></i>
                                                </a>

                                                @if (!$creditNote->trashed()) <!-- Check if the record is not soft-deleted -->
                                                    <a href="{{ route('crusher.credit_notes.edit', ['credit_note' => $creditNote->id]) }}">
                                                        <i class="far fa-edit cust-icon2"></i>
                                                    </a>

                                                    <form action="{{ route('crusher.credit_notes.delete') }}" method="POST" class="d-inline">
                                                        @csrf
                                                        @method('DELETE')
                                                        <input type="hidden" name="invoice_no" value="{{ $creditNote->invoice_no }}">
                                                        <button onclick="return confirm('Sure want to delete?')" type="submit" class="btn btn-link p-0 m-0 text-danger">
                                                            <i class="far fa-window-close cust-icon2"></i>
                                                        </button>
                                                    </form>
                                                @else <!-- If the record is soft-deleted, mark it as deleted -->
                                                    <span class="text-danger">Deleted</span>
                                                @endif
                                            </td>
                                        </tr>
                                    @empty
                                    @endforelse
                                </tbody>
                            </table>
                        </div>


                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->
@endsection
