@extends('layouts.master_user_without_nav')
@section('css')
<style>
    .margin_top{
        margin-top: 50px;
    }
    h2{
        margin-bottom: 20px;
    }
    #custom-search-input {
        padding: 3px;
        border: solid 1px #E4E4E4;
        border-radius: 6px;
        background-color: #fff;
    }

    #custom-search-input input {
        border: 0;
        box-shadow: none;
    }

    #custom-search-input button {
        margin: 2px 0 0 0;
        background: none;
        box-shadow: none;
        border: 0;
        color: #666666;
        padding: 0 8px 0 10px;
        border-left: solid 1px #ccc;
    }

    #custom-search-input button:hover {
        border: 0;
        box-shadow: none;
        border-left: solid 1px #ccc;
    }

    #custom-search-input .glyphicon-search {
        font-size: 23px;
    }


</style>
@endsection
@section('content')
<div class="middle-box text-center animated fadeInDown">
    <div class="row text-left" style="margin-bottom: 20px;">
        <a href="/" class="btn btn-primary">Go Back</a>
    </div>
    @include('errors.list')
        <div class="row gray-bg">
            <h2><strong>View,Edit,Print Invoice / Voucher</strong></h2>
        </div>
        <form class="margin_top" method="POST" action="/view-edit-print-invoice-voucher">
            @csrf
            <div class="form-group">
                <label for="country">Select Country</label>
                <select class="form-control" name="country" required>
                    <option value="">Select Country</option>
                    @foreach ($countries as $country)
                        <option value="{{$country-> id}}">{{$country-> name}}</option>
                    @endforeach
                </select>
                <input type="hidden" name="permission_option" id="permission_option" value="{{$permission_option}}">
            </div>
            <div class="form-group">
                <label for="location">Select Location</label>
               <select name="location" id="location" class="form-control" required>
               </select>
            </div>
            <div class="form-group">
                <label for="voucher">Select Voucher</label>
                <select name="voucher" id="voucher" class="form-control" required>
                    <option value="">Select Voucher</option>
                    <option value="approval-vouchers">Approval Voucher</option>
                    <option value="sales-invoices">Sales Invoice</option>
                    <option value="purchase-invoices">Purchase Invoice</option>
                    <option value="sales-return-vouchers">Credit Note</option>
                    <option value="purchase-return-vouchers">Debit Note</option>
                    <option value="payment-vouchers">Payment Voucher</option>
                    <option value="receipt-vouchers">Receipt Voucher</option>
                    <option value="journal-vouchers">Journal Voucher</option>
                </select>
            </div>
            <div class="form-group">

                    <div id="custom-search-input">
                        <div class="input-group">
                            <input type="text" name="invoice_no" id="invoice_no" class="form-control input-lg" placeholder="Invoice / Voucher#" required>
                            <span class="input-group-btn">
                                <button class="btn btn-info btn-lg" type="button">
                                    <i class="glyphicon glyphicon-search"></i>
                                </button>
                            </span>
                        </div>
                </div>
            </div>
            <div class="form-group m-t-md">
                <button type="submit" class="btn btn-primary block full-width ">Search</button>
            </div>

        </form>
</div>
@endsection

@section('js')
<script>
</script>
@endsection
